library xsch;

import 'dart:io';

import 'package:audioplayers/audioplayers.dart';
import 'package:flutter/material.dart';
import 'package:collection/collection.dart';
import 'package:date_field/date_field.dart';
import 'package:flutter/services.dart';
import 'package:flutter_sound/flutter_sound.dart';
import 'package:image_picker/image_picker.dart';
import 'package:intl/intl.dart';
import 'package:photo_view/photo_view.dart';
import 'package:photo_view/photo_view_gallery.dart';
import 'package:uuid/uuid.dart';
import 'package:video_player/video_player.dart';
import 'package:xcommonwidgets/XViewWidgets/XResizer.dart';
import 'package:xcommonwidgets/xcommonwidgets.dart';
import 'package:xfxbase/XFDataItem.dart';
import 'package:xfxbase/_XFX/XF_Col.dart';
import 'package:xfxbase/_XFX/XF_View.dart';
import 'package:xfxbase/xfxbase.dart';
import 'package:xfxwidgets/XF_MAIN/XApp.dart';
import 'package:xtoolspackage/XLibStorage.dart';
import 'package:video_thumbnail/video_thumbnail.dart' as thumb;

import 'package:xtoolspackage/xtoolspackage.dart';

import '../XF_ELENCO/XElenco.dart';
import '../XMediaRecorder.dart';
import '../XTabItem.dart';
import '../xMediaItem.dart';
import '../xfxwidgets.dart';

part 'Xfx_SchComponents.dart';

class XScheda<T extends XFDataItem> extends StatefulWidget {
  //Ci facciamo passare l'oggetto da visualizzare T
  XScheda(
    this.itemInEdit,
    this.xView, {
    this.xApp,
    super.key,
    this.title,
    this.title_BackColor,
    this.title_Color,
    this.title_Widgets,
    this.btnOK_label = "OK",
    this.btnCancel_label,
    this.modeDialog_Active = false,
    this.modePage_Active = true,
    this.editable = true,
    this.decoration,
    this.width,
    this.cell_borderColor,
    this.cell_borderColor_Disabled,
    this.cell_labelColor_Disabled,
    this.allowAddDetts = false,
    this.viewSch_TYPE,
    this.xOnReturnBackFromScheda,
    this.liDetts_SchView,
    this.liXViewsApp,
    this.borderAree_Header,
    this.liDetts_SubArea,
    this.complexUI = false,
    this.viewDettsAlways = false,
    this.showHead = true,
    this.xDett_minHeight_showHead = true,
    this.xDett_AddBTN_Active = true,
  }) : super() {
    if (this.title_Widgets == null && modeDialog_Active == true) {
      //gestisco i titoli che verranno messi
      this.title_Widgets = [
        XContainerWithLabel(
          title,
          textStyle: XStyles.xStyTextForSubLabel(this.title_Color ?? XColors.foregroundLight),
          color: this.title_BackColor ?? XColors.backGroundTitleContainerForScheda_MAIN,
        ),
      ];
    }
  }
  T itemInEdit;
  final XView xView;
  late List<Widget>? title_Widgets;
  String? btnOK_label;
  String? btnCancel_label;
  String? title;
  Color? title_BackColor;
  Color? title_Color;
  bool modeDialog_Active;
  bool modePage_Active;
  bool editable;
  bool viewDettsAlways;
  bool complexUI;
  bool allowAddDetts;
  double? width;
  Decoration? decoration;
  Color? cell_borderColor;
  Color? cell_borderColor_Disabled;
  Color? cell_labelColor_Disabled;

  ///Se FALSE fa vedere le TABS al posto dell'elenco a fazzolettone / Se TRUE fas vedere l'elenco a fazzolettone  / se NULL fa vedere l'elenco semplice di RWO sotto l'header
  bool? viewSch_TYPE;
  bool? borderAree_Header;
  bool showHead;
  bool xDett_minHeight_showHead;
  bool xDett_AddBTN_Active;

  ///Se TRUE = fa vedere le TABS al posto dell'elenco a fazzolettone / Se FALSE fas vedere l'elenco a fazzolettone con dentro la scheda / se NULL fa vedere l'elenco semplice di RWO sotto l'header
  bool? liDetts_SchView;
  List<XView>? liXViewsApp;
  Widget? Function(dynamic)? liDetts_SubArea;
  Function(void Function(void Function()), bool)? xOnReturnBackFromScheda;
  Function(XFDataItem)? detts_OnTapItem;
  Function(XFDataItem)? detts_OnLongTapItem;
  XApp? xApp;
  GlobalKey? key_head;
  GlobalKey? key_detts;
  @override
  State<XScheda<T>> createState() => XSchedaState<T>();
}

class XSchedaState<T extends XFDataItem> extends State<XScheda<T>> with TickerProviderStateMixin {
  //Propietà della Scheda
  TextEditingController sconto_Controller = TextEditingController();
  ValueNotifier<bool> editedPage = ValueNotifier(false);
  bool isBusy = false;
  late T itemInEdit_Clone;
  int currentTabIndex = 0;
  XTabItem? xTab_Active = null;

  double percent_TopArea = 0.4;
  double percent_BottomArea = 0.6;

  String xFormat_Date = "dd/MM/yyyy";

  //Per far scomparire la UI sotto
  bool enteredInEditOnCell = false;
  bool btnUpdateChangesShow = false;
  bool borderColor_Active = false;

  ImagePicker? imagePicker;
  Directory cameraDirectory = Directory("/storage/emulated/0/DCIM/Camera/");

  final List<XMediaItem> _liMediaRAW = List<XMediaItem>.empty(growable: true);

  //Per Audio
  List<AudioPlayer>? audioPlayers;
  int selectedPlayerIdx = 0;
  FlutterSoundRecorder? _audioRecorder = FlutterSoundRecorder();
  AudioPlayer get selectedAudioPlayer => audioPlayers![selectedPlayerIdx];

  bool? createAudio = false;
  File? xFileUI;

  List<XBottomNavigationBarItem> liBottomActions = List<XBottomNavigationBarItem>.empty(growable: true);
  List<dynamic> liDelItems = List<dynamic>.empty(growable: true);
  ScrollController _scrollController = ScrollController();
  //DD final GlobalKey<FormState> _formkey = GlobalKey();
  String waiterMessage = "";
  static bool media_isActive = false;
  static double heightOfEntryField = 46;
  static Color color_Text = Color.fromARGB(255, 255, 255, 255);
  static Color color_LabelText = Color.fromARGB(255, 255, 255, 255);
  static Color color_HintText = Color.fromARGB(255, 105, 105, 105);
  static Color color_TextDisabled = Color.fromARGB(255, 75, 75, 75);
  static Color color_Border = Colors.grey[600]!; //Color.fromARGB(255, 62, 62, 62);
  static Color color_BorderDisabled = Colors.grey[600]!; // Color.fromARGB(255, 48, 48, 48);
  static Color color_AppBar_Background = Colors.grey[900]!;
  static Color color_BackGround_EditDialog = Color.fromARGB(255, 30, 30, 30);
  static Color? color_CellBackGorundDisabled;
  static double widthBetweenCell = 10;

  ///Per gestire i Tab
  late TabController tabController;
  ValueNotifier<List<XTabItem>> xTabs = ValueNotifier<List<XTabItem>>([]);
  TickerProvider? vsync;

  //Per Gestire i tabbed della scheda nell visualizzazione a paginate e non a fazzolettone
  TabController? detts_tabController;
  List<XTabItem> liDettTabs = List<XTabItem>.empty(growable: true);

  //Per gestire EditDialog
  List<XProp> xEditDialog_liProps = List<XProp>.empty(growable: true);
  String xEditDialog_EditCell = "";

  bool dettHeader_Active = false;
  void superSetState(VoidCallback fn) => setState(fn);
  @override
  void initState() {
    widget.viewSch_TYPE = true;
    widget.detts_OnTapItem = (item) => _on_xDetts_Action_Edit(item);
    widget.detts_OnLongTapItem = (item) => _on_xDetts_Action_Delete(item);

    audioPlayers = [AudioPlayer(playerId: "1")];
    widget.cell_borderColor = XSchedaState.color_Border;
    widget.cell_borderColor_Disabled = XSchedaState.color_BorderDisabled;
    widget.cell_labelColor_Disabled = XSchedaState.color_LabelText; //color_TextDisabled;

    if (widget.itemInEdit.id == "") widget.itemInEdit.isNew = true;

    //Inizializzo la Scheda
    init_Sch();

    _xfillxTabs();

    //Inizializzo la BottomBar
    xFillBottomBarActions();
    //Inizializzo le TABS con le liste dei Detts della Scheda
    if (xTabs.value.isNotEmpty) {
      xTab_Active = xTabs.value.first;
    }

    super.initState();
  }

  Future<XFDataItem> _on_xDetts_Action_Delete(XFDataItem item) async {
    editedPage.value = true;

    return await xDetts_Action_Delete(item);
  }

  Future<XFDataItem> _on_xDetts_Action_Edit(XFDataItem item) async {
    editedPage.value = true;

    return await xDetts_Action_Edit(item);
  }

  Future<XFDataItem> xDetts_Action_Delete(XFDataItem item) async {
    return item;
  }

  Future<XFDataItem> xDetts_Action_Edit(XFDataItem item) async {
    return item;
  }

  @override
  void dispose() {
    _scrollController.dispose();
    // detts_tabController!.dispose();
    if (_audioRecorder != null) {
      _audioRecorder!.closeRecorder();
      _audioRecorder = null;
    }
    super.dispose();
  }

  ///Inizializzo la scheda riempendo l'Item Clone per avere possibilità di fare UNDO
  /// mi cerco in li*Raw i miei dettagli
  init_Sch() {
    itemInEdit_Clone = widget.itemInEdit.getCloneFull() as T;
    updateCaption();
  }

  ///Da Overridare per gestire il salvatggio dei dati su Cloud o DB
  xOnSaveAfter() async {
    throw Exception("DEVI OVERRIDE questo metodo! xOnSaveAfter");
  }

  ///Da Overridare per gestire l'aggiunta di un Item
  Future<bool> xOnAddDett(T item) async {
    return false;
  }

  ///Da Overridare per gestire gestire i titoli delle sezioni delle celle nell'HEAD
  Widget xLayout_GetTitleWidget(int originY) {
    if (widget.modePage_Active) {
      return Container(width: 0, height: 0);
    } else {
      if (widget.title_Widgets == null || widget.title_Widgets!.isEmpty) {
        return Container(width: 0, height: 0);
      } else {
        var titleIdxFromOriginY = 0;
        if (originY > 0) {
          titleIdxFromOriginY = originY ~/ 2;
          if (titleIdxFromOriginY > widget.title_Widgets!.length - 1) titleIdxFromOriginY = 0;
        }
        return widget.title_Widgets == null ? Container(width: 0, height: 0) : widget.title_Widgets![titleIdxFromOriginY];
      }
    }
  }

  ///Da overridare per sovrascrivere il Widget all'interno dell'EdiDialog
  Widget? xEditDialog_Override_Editor(String title, dynamic value, XCol<dynamic> xCol, TextEditingController controller, {dynamic item}) {
    return null;
  }

  ///BUILDER DEI WIDGET NON EDITABILI///
  Container xLayout_CellWidget(XCol xCol, dynamic item, BuildContext context) {
    if (xCol.colKey.startsWith("li")) return Container();

    late Widget _widgetForCell;

    if (xCol.dataType == DateTime) {
      _widgetForCell = xSch_TextFormField_Builder(
        context: context,
        xCol: xCol,
        multiLines: xCol.multilines,
        editable: xCol.allowEditing,
        hintText: "",
        onBefore_Edit: () {},
        value: XUtils.dateToString(item[xCol.colKey] != null ? item[xCol.colKey] : DateTime(1900, 01, 01), noDateLabel: ""),
        onChanged: (value) {},
      );
    } else if (xCol.dataType == bool) {
      _widgetForCell = Container(
        child: XCheckBoxWidget(
          verticalCheckBoxWidget: true,
          label: xCol.colCaption,
          label_Color: xCol.xmodelXprop.col_Color != Colors.black ? xCol.xmodelXprop.col_Color : XColors.foregroundLight,
          activeColor: xCol.xmodelXprop.col_Color != Colors.black ? xCol.xmodelXprop.col_Color : XColors.foregroundLight,
          checkColor: Colors.black,
          value: (item[xCol.colKey] ?? false),
        ),
      );
    } else {
      _widgetForCell = xSch_TextFormField_Builder(
        context: context,
        xCol: xCol,
        editable: xCol.allowEditing,
        multiLines: xCol.multilines,
        hintText: "",
        onBefore_Edit: () {},
        value: item[xCol.colKey].toString(),
        onChanged: (value) {},
      );
    }

    if (xCol.resizeStyle == 0) {
      // return Container(height: 40, constraints: BoxConstraints(minWidth: double.infinity, maxWidth: double.infinity), child: Container(margin: EdgeInsets.symmetric(horizontal: 2), child: _widgetForCell));
      return Container(constraints: BoxConstraints.tightForFinite(height: XSchedaState.heightOfEntryField), child: Container(margin: EdgeInsets.symmetric(horizontal: 4), child: _widgetForCell));
    }
    //Se la colonna è Width PROPORTIONAL
    else if (xCol.resizeStyle == 1) {
      return Container(width: xCol.width, constraints: BoxConstraints(minWidth: xCol.width * .9, maxWidth: xCol.width * 1.2), margin: EdgeInsets.symmetric(horizontal: 4), child: _widgetForCell);
    }
    //Se la colonna è Width FIX
    else {
      return Container(width: xCol.width, margin: EdgeInsets.symmetric(horizontal: 4), child: _widgetForCell);
    }
  }

  ///se chiamato dopo che è stato aggiunto un dettaglio, il xCol è NULL e newValue è l'item del dettaglio aggiunto
  calcDoc(XCol? xCol, dynamic newValue) {}

  ///BUILDER DEI WIDGET EDITABILI///
  Container xLayout_CellWidget_Editable(XCol xCol, dynamic item, BuildContext context, dynamic itemToSet, {bool onBeforeCMD_Active = true, TextEditingController? controller}) {
    late Widget _widgetForCell;
    //WIDGET NEL CASO FOSSE UNA STRING
    if (xCol.dataType == String && xCol.colKey.startsWith("li").not() && xCol.dataType != bool) {
      _widgetForCell = xSch_TextFormField_Builder(
        height: null,
        context: context,
        controller: controller,
        xCol: xCol,
        multiLines: xCol.width >= 200 ? true : false,
        editable: xCol.readOnly,
        borderColor: widget.cell_borderColor,
        borderColor_Disabled: widget.cell_borderColor_Disabled,
        labelColor_Disabled: widget.cell_labelColor_Disabled,
        onSubmitted: (value) {
          xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, value);
        },
        onBefore_Edit: () {
          if (onBeforeCMD_Active) {
            xOnXCell_Before_Edit(xCol, item[xCol.colKey], itemToSet: itemToSet);
          }
        },
        value: item[xCol.colKey] ?? "",
        onChanged: (value) {
          xOnXCell_Edit_OnChanged(item, xCol, value);
        },
      );
    }
    //WIDGET NEL CASO FOSSE UN DATETIME
    else if (xCol.dataType == DateTime) {
      _widgetForCell = xSch_DateFormField_Builder(
          xCol: xCol,
          borderColor: widget.cell_borderColor,
          borderColor_Disabled: widget.cell_borderColor_Disabled,
          labelColor_Disabled: widget.cell_labelColor_Disabled,
          format: xFormat_Date,
          onBefore_Edit: () => xOnXCell_Before_Edit(xCol, item),
          value: item[xCol.colKey] == DateTime(1900, 01, 01) ? null : item[xCol.colKey],
          onDateSelected: (value) {
            xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, value);
          });
    }
    //WIDGET NEL CASO FOSSE UN DOUBLE
    else if (xCol.dataType == double) {
      _widgetForCell = xSch_TextFormField_Builder(
          context: context,
          selectText: true,
          editable: xCol.readOnly,
          xCol: xCol,
          controller: controller,
          maxLines: 1,
          borderColor: widget.cell_borderColor,
          borderColor_Disabled: widget.cell_borderColor_Disabled,
          labelColor_Disabled: widget.cell_labelColor_Disabled,
          onBefore_Edit: () {
            if (onBeforeCMD_Active) {
              xOnXCell_Before_Edit(xCol, item, itemToSet: itemToSet);
            }
          },
          keyboardType: TextInputType.number,
          value: (item[xCol.colKey] == null || item[xCol.colKey].toString() == "0.0") ? "" : XUtils.xFormatDouble(context, item[xCol.colKey]),
          inputFormatters: [FilteringTextInputFormatter.deny(RegExp("[- /,\\\\]"))],
          onSubmitted: (value) {
            xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, double.parse(value));
          },
          onChanged: (value) {
            if (value != "") {
              xOnXCell_Edit_OnChanged(item, xCol, double.parse(value));
            } else {
              xOnXCell_Edit_OnChanged(item, xCol, 0.0);
            }
          });
    }
    //WIDGET NEL CASO FOSSE UN INTERO
    else if (xCol.dataType == int) {
      _widgetForCell = xSch_TextFormField_Builder(
        context: context,
        editable: xCol.readOnly,
        selectText: true,
        maxLines: 1,
        controller: controller,
        xCol: xCol,
        borderColor: widget.cell_borderColor,
        borderColor_Disabled: widget.cell_borderColor_Disabled,
        labelColor_Disabled: widget.cell_labelColor_Disabled,
        keyboardType: TextInputType.number,
        onBefore_Edit: () {
          if (onBeforeCMD_Active) {
            xOnXCell_Before_Edit(xCol, item, itemToSet: itemToSet);
          }
        },
        onSubmitted: (value) {
          xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, value);
        },
        value: item[xCol.colKey].toString() == "0.0" ? "" : XUtils.xFormatInt(context, item[xCol.colKey]),
        inputFormatters: [FilteringTextInputFormatter.deny(RegExp("[- /,\\\\]"))],
        onChanged: (value) {
          if (value != "") {
            xOnXCell_Edit_OnChanged(item, xCol, int.parse(value));
          } else {
            xOnXCell_Edit_OnChanged(item, xCol, 0);
          }
        },
      );
    } else if (xCol.dataType == bool) {
      _widgetForCell = Container(
        child: XCheckBoxWidget(
            verticalCheckBoxWidget: true,
            label: xCol.colCaption,
            label_Color: xCol.xmodelXprop.col_Color != Colors.black ? xCol.xmodelXprop.col_Color : XColors.foregroundLight,
            activeColor: xCol.xmodelXprop.col_Color != Colors.black ? xCol.xmodelXprop.col_Color : XColors.foregroundLight,
            checkColor: XColors.foregroundDark,
            value: (item[xCol.colKey] ?? false),
            onChanged: (value) async {
              setState(() {
                xOnXCell_Edit_SubmitValue_INTERNAL(item, xCol, value);
                editedPage.value = true;
                item[xCol.colKey] = value;
              });
            }),
      );
    } else {
      //DEVE essere W e H = 0 se no il Wrap fa casino nel gestirlo e va a "un po' a capo" dopo l'ultimo Widget
      return Container(width: 0, height: 0);
    }
    return Container(
      width: xCol.width,
      padding: xCol.dataType == DateTime ? EdgeInsets.only(top: 1 * (XUtils.kforScale)) : null,
      child: _widgetForCell,
    );
    //}
  }

  ///Da overridare per aggiungere Widgets nelle Actions dell'AppBar
  List<Widget> xLayout_AppBar_AdditionalActions() {
    return [];
  }

  ///Da overridare per Modificare la costruzione totale Dell'Item dei dettagli
  Widget? xLayout_ItemWidget(dynamic item) {
    return null;
  }

  ///Da overridare per aggiungere Widgets nel widget XResized prima del titolo
  List<Widget> xLayout_XResizer_AdditionalWidgets_BeforeTitle() {
    return [];
  }

  ///Da overridare per aggiungere Widgets nel widget XResized prima del titolo
  List<Widget> xLayout_XResizer_AdditionalWidgets_AfterTitle() {
    return [
      // XBtnbase(
      //     icon: dettHeader_Active ? Icons.expand_less : Icons.expand_more,
      //     height: 35,
      //     width: 35,
      //     icon_Size: 20,
      //     onPressed: () {
      //       setState(() {
      //         dettHeader_Active = dettHeader_Active.not();
      //       });
      //     },
      //     backGroundColor: dettHeader_Active ? Colors.yellow : Colors.green),
    ];
  }

  ///Da overridare per Modificare la costruzione totale del Widget delle ROW
  Widget? xTabView_Widget(XCol xCol) {
    var typeProp = itemInEdit_Clone.getProp(xCol.colKey).runtimeType;
    var xViews_Flutter = widget.liXViewsApp!.firstWhereOrNull((element) => element.viewKey.contains((typeProp.toString().replaceAll("List<", "").replaceAll(">", "_Flutter"))) && element.viewKey.contains("el_"));
    return StatefulBuilder(
      builder: (context, setState) {
        if (widget.viewSch_TYPE == true) {
          return XElenco(
            xCol.colCaption,
            typeProp != Type
                ? xViews_Flutter != null
                    ? xViews_Flutter
                    : null
                : null,
            elDettsMode_SchItem: widget.liDetts_SchView,
            pageMode_Active: false,
            onTapItem: (item) async {
              super.setState(() {
                waiterMessage = "Sto caricando...";
                enteredInEditOnCell = true;
              });
              if (widget.detts_OnTapItem != null) {
                var x = await widget.detts_OnTapItem!(item as XFDataItem);
                if (x != null) {
                  super.setState(() {
                    editedPage.value = true;
                    enteredInEditOnCell = false;
                    waiterMessage = "";
                  });
                  return;
                }
              }
              xFillBottomBarActions();
              super.setState(() {
                waiterMessage = "";
                enteredInEditOnCell = false;
              });
            },
            cmd_Add: (a) {
              xOnAddDett(itemInEdit_Clone);
            },
            xOnReturnBack: (setState) {
              super.setState(() {
                editedPage.value = true;
                enteredInEditOnCell = false;
                widget.xOnReturnBackFromScheda != null ? widget.xOnReturnBackFromScheda!(super.setState, enteredInEditOnCell) : null;
              });
            },
            liWidgets_LeftArea_Item: (item) => xDett_Item_LeftWidgets(item, setState),
            schedaMode: false,
            edited: editedPage,
            appBar_Color: widget.title_BackColor,
            onLongTapItem: (item) => xDett_Item_xOnLongTap(item),
            liDettsSubArea_Widgets: (value) => xLayout_Widget_UnderDett(value, setState),
            item_Widget: xLayout_ItemWidget(itemInEdit_Clone) != null ? ((item) => xLayout_ItemWidget(item)) : null,
            searchBar_Active: true,
            schNameToOpen: typeProp != Type ? "/Sch${typeProp.toString().replaceAll("List<", "").replaceAll(">", "")}" + ".dart" : null,
            liDetts: itemInEdit_Clone.getProp(xCol.colKey),
          );
        } else if (widget.viewSch_TYPE == false) {
          xTabViewDett_Widget(xCol, 0, setState);
          // detts_tabController = TabController(length: xTabs.value.length, vsync: this);

          return XfxSchedaTabbed(
            margin_Horizontal: 0,
            tabs_BackGroundColor: Colors.grey[900],
            title_Visible: false,
            bottomBar_Visible: false,
            bottomBar_Children: [],
            // numberOfTabs: detts_tabController!.length,
            isScrollableTabs: true,
            children: liDettTabs.map((x) => x.content!).toList(),
            xTabs: liDettTabs,
          );
        } else {
          return XElenco(
            xCol.colCaption,
            typeProp != Type
                ? xViews_Flutter != null
                    ? xViews_Flutter
                    : null
                : null,
            elDettsMode_SchItem: true,
            onLongTapItem: (item) => xDett_Item_xOnLongTap(item),
            pageMode_Active: false,
            liWidgets_LeftArea_Item: (item) => xDett_Item_LeftWidgets(item, setState),
            onTapItem: (item) async {
              super.setState(() {
                waiterMessage = "Sto caricando...";
                enteredInEditOnCell = true;
              });
              if (widget.detts_OnTapItem != null) {
                var x = await widget.detts_OnTapItem!(item as XFDataItem);
                if (x != null) {
                  super.setState(() {
                    editedPage.value = true;
                    enteredInEditOnCell = false;
                    waiterMessage = "";
                  });
                  return;
                }
              }
              super.setState(() {
                waiterMessage = "";
                enteredInEditOnCell = false;
              });
              tabsChangeActive(xCol.colKey);
            },
            cmd_Add: (a) {
              xOnAddDett(itemInEdit_Clone);
            },
            xOnReturnBack: (setState) {
              super.setState(() {
                editedPage.value = true;
                enteredInEditOnCell = false;
                widget.xOnReturnBackFromScheda != null ? widget.xOnReturnBackFromScheda!(super.setState, enteredInEditOnCell) : null;
              });
            },
            edited: editedPage,
            appBar_Color: widget.title_BackColor,
            liDettsSubArea_Widgets: (value) => xLayout_Widget_UnderDett(value, setState),
            item_Widget: xLayout_ItemWidget(itemInEdit_Clone) != null ? ((item) => xLayout_ItemWidget(item)) : null,
            schedaMode: true,
            searchBar_Active: true,
            schNameToOpen: typeProp != Type ? "/Sch${typeProp.toString().replaceAll("List<", "").replaceAll(">", "")}" + ".dart" : null,
            liDetts: itemInEdit_Clone.getProp(xCol.colKey),
          );
        }
      },
    );
  }

  ///Da overridare per Modificare la costruzione totale del Widget all'interno degli ItemDett delle ROW
  Widget? xTabViewDett_Widget(dynamic d, int idxTab, void Function(void Function()) parentSetState) {
    return null;
  }

  ///Da overridare per Modificare la costruzione totale della Pagina
  Widget? xLayout_BodyBuild() {
    return null;
  }

  // ///Da overridare per Modificare la costruzione totale della Pagina
  Widget xLayout_HeadBuild({XView? xclView}) {
    return StatefulBuilder(builder: (context, setState) {
      return Container(child: Scrollbar(thumbVisibility: true, controller: _scrollController, child: SingleChildScrollView(controller: _scrollController, child: Container(margin: EdgeInsets.only(bottom: 10), decoration: widget.decoration ?? BoxDecoration(), child: Column(crossAxisAlignment: CrossAxisAlignment.start, mainAxisSize: MainAxisSize.min, children: widget.showHead ? xLayout_Render_HeadView(xclView != null ? xclView : widget.xView) : [])))));
    });
  }

  ///Da overridare per Modificare la parte sotto all'HEAD
  Widget? xLayout_Widget_UnderDett(dynamic d, void Function(void Function()) parentSetState) {
    if (widget.liDetts_SubArea != null) {
      return widget.liDetts_SubArea!(d);
    } else {
      return null;
    }
  }

  xLayout_Widget_IfEmptyList(XFDataItem dataItem) async {
    return false;
  }

  List<Widget>? xLayout_bottomArea_OverSch() {
    return null;
  }

  ///Layout della Scheda se è visualizzata come Pagina completa
  Widget xLayout_asPage(BuildContext context) {
    // var ifMore = widget.xView.cols.where((element) => element.colKey.startsWith("li"));
    // var i;
    // if (ifMore.isNotEmpty) {
    //   i = itemInEdit_Clone[ifMore.first.colKey];
    // } else {
    //   i = "";
    // }

    return WillPopScope(
        onWillPop: () => cmd_Back(),
        child: GestureDetector(
            onTap: () => FocusScope.of(context).unfocus(),
            child: Scaffold(
              appBar: AppBar(
                iconTheme: IconThemeData(color: widget.title_BackColor ?? XColors.foregroundDark),
                title: Text(((widget.title ?? "").replaceAll("App", "")), style: XStyles.xStyTextForLabel(widget.title_BackColor ?? XColors.foregroundDark)),
                backgroundColor: widget.title_Color,
                actions: [
                  Row(children: [
                    // (i != "" && i.length > 1)
                    //     ? XBtnbase(
                    //         label: "Cambia \nVisione",
                    //         onPressed: () {
                    //           setState(() {
                    //             if (widget.viewSch_TYPE != null) {
                    //               widget.viewSch_TYPE = widget.viewSch_TYPE!.not();
                    //             } else {
                    //               widget.viewSch_TYPE = false;
                    //             }
                    //             rebuildAllChildren(context);
                    //           });
                    //         },
                    //         icon_Size: 25,
                    //         elevation: 0,
                    //         icon_WidthArea: 30,
                    //         backGroundColor: widget.title_BackColor,
                    //         icon_Color: widget.title_BackColor ?? XColors.foregroundDark,
                    //         width: 100,
                    //       )
                    //     : Container(),
                    widget.allowAddDetts
                        ? Container(
                            margin: EdgeInsets.only(bottom: 5, top: 5, right: 5),
                            child: Row(children: [
                              XBtnbase(
                                icon: Icons.add,
                                onPressed: () async {
                                  setState(() {
                                    waiterMessage = "Sto caricando...";
                                    isBusy = true;
                                  });
                                  await xOnAddDett(itemInEdit_Clone).then((value) {
                                    super.setState(() {
                                      waiterMessage = "";
                                      isBusy = false;
                                    });
                                  });
                                },
                                icon_Size: 25,
                                elevation: 0,
                                icon_WidthArea: 30,
                                backGroundColor: widget.title_BackColor,
                                icon_Color: widget.title_BackColor ?? XColors.foregroundDark,
                                height: 40,
                                width: 40,
                              ),
                            ]))
                        : Container(),
                    Container(margin: EdgeInsets.only(bottom: 8, right: 5), child: Row(children: xLayout_AppBar_AdditionalActions())),
                  ])
                ],
              ),
              body: Stack(children: [
                xLayout_BodyBuild() != null
                    ? xLayout_BodyBuild() ?? Container()
                    : this.xTabs.value.isNotEmpty || widget.viewDettsAlways
                        ? XResizableWidget(
                            // key_Head: widget.key_head!,
                            // key_Detts: widget.key_detts!,
                            key: GlobalKey(),
                            isHorizontalSeparator: true,
                            title: this.xTabs.value.length <= 1 ? this.xTabs.value.first.caption : "",
                            separatorColor: Colors.grey[700]!,
                            separatorSize: 40,
                            onResized: (infoList) {
                              percent_TopArea = infoList.first.percentage < 0.2 ? 0.2 : double.parse(infoList.first.percentage.toStringAsFixed(1));
                              percent_BottomArea = infoList.last.percentage < 0.2 ? 0.2 : double.parse(infoList.last.percentage.toStringAsFixed(1));
                            },
                            xWidgets_BeforeTitle: xLayout_XResizer_AdditionalWidgets_BeforeTitle(),
                            xWidgets_AfterTitle: xLayout_XResizer_AdditionalWidgets_AfterTitle(),
                            percentages: [percent_TopArea, percent_BottomArea],
                            children: [
                              widget.showHead ? xLayout_HeadAreaBuilder() : Container(),
                              this.xTabs.value.isEmpty
                                  ? Container(height: 0)
                                  : Stack(
                                      alignment: Alignment.bottomCenter,
                                      children: [
                                        this.xTabs.value.length <= 1
                                            ? this.xTabs.value.map((x) => widget.complexUI ? x.content ?? Container() : x.xElencoToView ?? Container()).first
                                            : XfxSchedaTabbed(
                                                margin_Horizontal: 0,
                                                tabs_BackGroundColor: Colors.grey[900],
                                                title_Color: widget.title_Color,
                                                currentTabIdx: (xTabs.value.isEmpty || xTab_Active == null) ? (xTabs.value.isEmpty ? 0 : xTabs.value.first.idx) : xTab_Active!.idx,
                                                title_Visible: false,
                                                bottomBar_Visible: false,
                                                bottomBar_Children: [],
                                                numberOfTabs: this.xTabs.value.length,
                                                isScrollableTabs: this.xTabs.value.length >= 4 ? true : false,
                                                children: this.xTabs.value.map((x) => (widget.complexUI ? x.content ?? Container() : x.xElencoToView ?? Container())).toList(),
                                                xTabs: this.xTabs.value,
                                              ),
                                        Column(crossAxisAlignment: CrossAxisAlignment.end, mainAxisAlignment: MainAxisAlignment.end, children: xLayout_bottomArea_OverSch() ?? []),
                                      ],
                                    ),
                            ],
                          )
                        : widget.showHead
                            ? enteredInEditOnCell
                                ? Container()
                                : xLayout_HeadAreaBuilder()
                            : Container(),
                isBusy ? Container(color: Colors.black.withAlpha(180)) : Container(),
                isBusy ? XStatefulWidgetBase.LoaderIndicator(isBusy, label: waiterMessage) : Container(),
              ]),
              bottomNavigationBar: (liBottomActions.length > 1) && widget.editable
                  ? BottomNavigationBar(
                      key: UniqueKey(),
                      items: liBottomActions,
                      type: BottomNavigationBarType.fixed,
                      currentIndex: 0,
                      onTap: (value) async => await _xBottomBarAction_OnTap(value, setState),
                      enableFeedback: true,
                      showUnselectedLabels: true,
                      selectedFontSize: 15,
                      selectedLabelStyle: XStyles.xStyleText(fontSize: 14, colorText: XColors.foregroundLight),
                      backgroundColor: Colors.grey[900],
                      unselectedItemColor: XColors.foregroundLight,
                      unselectedFontSize: 10,
                      useLegacyColorScheme: false,
                      unselectedLabelStyle: XStyles.xStyleText(fontSize: 14, colorText: XColors.foregroundLight),
                      iconSize: 20,
                    )
                  : null,
              floatingActionButton: widget.editable
                  ? xLayout_FloatingAddBTN_Widget() == null
                      ? (liBottomActions.length == 1 ? xLayout_FloatingAddBTN(liBottomActions[0]) : null)
                      : xLayout_FloatingAddBTN_Widget()
                  : null,
            )));
  }

  Widget? xLayout_FloatingAddBTN_Widget() {
    return null;
  }

  Widget xLayout_FloatingAddBTN(XBottomNavigationBarItem xbtnBarItem) {
    return XBtnbase(
        margin: EdgeInsets.only(bottom: 20),
        width: 50,
        height: 50,
        radiusBorder: 10,
        toolTip_Message: "${xbtnBarItem.label}",
        icon_Widget: xbtnBarItem.icon,
        icon_WidthArea: 50,
        icon_Color: xbtnBarItem.backgroundColor ?? widget.title_Color,
        backGroundColor: Colors.grey[800]!.withAlpha(150),
        onPressed: () async {
          xBottomBarAction_OnTap(0, xbtnBarItem, setState);
        });
  }

  ///Widget che torna un
  Widget xLayout_HeadAreaBuilder({XView? xclView}) {
    return widget.showHead
        ? enteredInEditOnCell
            ? Container()
            : Container(
                child: Scrollbar(
                    thumbVisibility: true,
                    controller: _scrollController,
                    child: SingleChildScrollView(
                        controller: _scrollController,
                        child: Form(
                            key: widget.key,
                            child: Container(
                                decoration: widget.decoration ?? BoxDecoration(),
                                child: Column(
                                  crossAxisAlignment: CrossAxisAlignment.start,
                                  mainAxisSize: MainAxisSize.min,
                                  children: xLayout_Render_HeadView(xclView != null ? xclView : widget.xView),
                                ))))))
        : Container();
  }

  List<Widget> xLayout_Render_HeadView(XView xview, {bool border_Visible = true}) {
    xLayout_maxRowLen = 0; //resetto
    var grps = xview.cols
        . //
        groupListsBy((element) => element.originY)
        .entries
        .toList();
    var lastY = grps.last.key;
    double avgColsInY = 0;
    grps.map((e) => avgColsInY += e.value.length).toList();
    avgColsInY = avgColsInY / grps.length;
    var r = grps.map(
      (e) {
        //x ogni Y
        //x orgni sottoROW/grp
        double rowLen = 0;
        var child = xLayout_Render_HeadView_Widget_forY(
            e,
            e.value.map((e) {
              var xwidgt = widget.editable ? xLayout_CellWidget_Editable(e, itemInEdit_Clone, context, itemInEdit_Clone) : xLayout_CellWidget(e, itemInEdit_Clone, context);
              rowLen += 10 + 5 + xwidgt.constraints!.minWidth;
              return xwidgt;
            }).toList(),
            lastY,
            border_Visible: border_Visible,
            avgColsInY > 3);
        if (rowLen > xLayout_maxRowLen) xLayout_maxRowLen = rowLen;
        return child;
      },
    ).toList();

    return r;
  }

  ///Da overridare per Modificare la composizione dei pezzi dell'HEAD
  Widget xLayout_Render_HeadView_Widget_forY(
    MapEntry<int, List<XCol<dynamic>>> e,
    List<Widget> children,
    int lastY,
    bool border_separator, {
    bool border_Visible = true,
    Color? border_color,
  }) {
    late BoxDecoration? border;
    late EdgeInsets? margin;
    if (border_Visible) {
      if (lastY == e.key) {
        if (children.length == 1) {
          margin = null;
          border = BoxDecoration(
              border: Border(
            bottom: BorderSide(width: 2, color: border_color ?? widget.title_Color ?? XColors.foregroundLight),
            left: BorderSide(width: 2, color: border_color ?? widget.title_Color ?? XColors.foregroundLight),
            right: BorderSide(width: 2, color: border_color ?? widget.title_Color ?? XColors.foregroundLight),
          ));
        } else {
          Color(0xff87d37c);
          //ultima e GRANDE
          margin = !border_separator ? null : EdgeInsets.only(top: 10);
          border = BoxDecoration(border: Border(bottom: BorderSide(width: 2, color: border_color ?? widget.title_Color ?? XColors.foregroundLight), left: BorderSide(width: 2, color: border_color ?? widget.title_Color ?? XColors.foregroundLight), right: BorderSide(width: 2, color: border_color ?? widget.title_Color ?? XColors.foregroundLight), top: border_separator ? BorderSide(width: 2, color: border_color ?? widget.title_Color ?? XColors.foregroundLight) : BorderSide.none));
        }
      } else {
        //prima e altre Y
        margin = e.key == 0 || children.length == 1 || !border_separator ? null : EdgeInsets.only(top: 10);
        if (children.length == 1 || !border_separator)
          border = BoxDecoration(border: border_Visible ? Border.symmetric(vertical: BorderSide(width: 2, color: border_color ?? widget.title_Color ?? XColors.foregroundLight)) : null);
        else
          border = BoxDecoration(border: border_Visible ? Border.all(width: 2, color: border_color ?? widget.title_Color ?? XColors.foregroundLight) : null);
      }
    } else
      border = null;
    margin = null;

    return Container(
        decoration: border,
        margin: margin,
        //padding: border != null ? null : EdgeInsets.only(left: 5, right: 5),
        padding: EdgeInsets.only(left: 5, right: 5, top: 4),
        child: Column(mainAxisSize: MainAxisSize.min, crossAxisAlignment: CrossAxisAlignment.start, children: [
          widget.modePage_Active ? Container(width: 0, height: 0) : xLayout_GetTitleWidget(e.key),
          widget.modePage_Active ? Container(width: 0, height: 0) : (widget.title_Widgets == null ? Container(width: 0, height: 0) : SizedBox(height: 15)),
          Container(
              padding: border_Visible ? EdgeInsets.only(bottom: 4, top: 4) : EdgeInsets.only(top: 0, bottom: 0, left: 0, right: 0),
              alignment: Alignment.topLeft,
              margin: border_Visible ? EdgeInsets.only(top: 5, left: 0, right: 0) : EdgeInsets.only(top: 0, bottom: 0, left: 0, right: 0),
              child: Wrap(
                runSpacing: 15,
                spacing: 5, //XSchedaState.widthBetweenCell,
                direction: Axis.horizontal,
                alignment: WrapAlignment.start,
                runAlignment: WrapAlignment.start,
                crossAxisAlignment: WrapCrossAlignment.start,
                children: children,
              ))
        ]));
  }

  double xLayout_maxRowLen = 0.0;

  ///Layout della Scheda se è visualizzata come Alert Dialog
  Widget xLayout_asDialog(Widget content) {
    double actionBTN_Heigth = 35;
    return AlertDialog(
        backgroundColor: Colors.grey[900],
        contentPadding: EdgeInsets.symmetric(horizontal: MediaQuery.of(context).size.width * 0.02, vertical: MediaQuery.of(context).size.width * 0.01),
        content: StatefulBuilder(builder: (BuildContext context, StateSetter setState) {
          return SingleChildScrollView(child: Container(decoration: BoxDecoration(border: Border.all(width: 3, color: color_HintText)), width: xLayout_maxRowLen, child: content));
        }),
        actionsAlignment: MediaQuery.of(context).size.width < 900 ? MainAxisAlignment.center : null,
        actions: [
          Container(
              child: Wrap(
            runAlignment: WrapAlignment.center,
            alignment: WrapAlignment.center,
            runSpacing: 20,
            spacing: 20,
            children: [
              Container(child: xLayout_HeadAreaBuilder()),
              Container(
                  margin: EdgeInsets.only(right: 20),
                  child: Row(crossAxisAlignment: CrossAxisAlignment.center, mainAxisSize: MainAxisSize.min, children: [
                    btnUpdateChangesShow
                        ? XBtnbase(
                            height: actionBTN_Heigth,
                            width: MediaQuery.of(context).size.width > 900 ? 180 : 100,
                            elevation: 0,
                            label: widget.btnOK_label,
                            decoration: xBoxDecorationStyleCircular_ForMenu(Colors.greenAccent[400]),
                            onPressed: () {
                              xcmd_Save();
                              Navigator.pop(context, widget.itemInEdit);
                            },
                            label_Style: XStyles.xStyTextForDescr(XColors.foregroundDark))
                        : Container(),
                    SizedBox(width: 10),
                    XBtnbase(
                      width: MediaQuery.of(context).size.width > 800 ? 180 : 100,
                      height: actionBTN_Heigth,
                      elevation: 0,
                      label: widget.btnCancel_label ?? "Cancel",
                      decoration: xBoxDecorationStyleCircular_ForMenu(Colors.redAccent),
                      onPressed: () => Navigator.pop(this.context, null),
                      label_Style: XStyles.xStyTextForDescr(XColors.foregroundDark),
                    ),
                  ]))
            ],
          ))
        ]);
  }

  ///Layout della Scheda se è visualizzata come un semplice Widget da inserire in UI
  Widget xLayout_asContainer() {
    return SingleChildScrollView(
        child: Container(
            decoration: widget.decoration ?? BoxDecoration(border: (widget.borderAree_Header ?? false) ? Border.all(width: 3, color: color_HintText) : null),
            width: widget.width ?? (MediaQuery.of(context).size.width > 1600 ? MediaQuery.of(context).size.width / 1.2 : MediaQuery.of(context).size.width / 1.2),
            child: Column(
              mainAxisSize: MainAxisSize.min,
              children: widget.showHead ? xLayout_Render_HeadView(widget.xView) : [],
            )));
  }

  ///Da Overridare se vuoi modificare il Layout delle celle dei Dettagli nell'area ROW della Scheda
  Widget xDett_Item_CellWidget(XCol xCol, XFDataItem item, bool noTextWhenCellValueIsNull, {String formatDate = "dd/MM/yy", int? maxLines}) {
    Widget _xContainerOfWidgets;

    if (xCol.dataType == String && xCol.colKey.startsWith("li").not()) {
      _xContainerOfWidgets = Text(item[xCol.colKey] != null ? item[xCol.colKey] : (noTextWhenCellValueIsNull ? "<No Text>" : ""),
          maxLines: maxLines != null
              ? maxLines
              : xCol.multilines
                  ? 3
                  : 1,
          style: XStyles.xStyTextForDescr(Colors.white),
          overflow: TextOverflow.ellipsis);
    }
    //WIDGET NEL CASO FOSSE UN DATETIME
    else if (xCol.dataType == DateTime) {
      _xContainerOfWidgets = Text(XUtils.dateToString(item[xCol.colKey] ?? DateTime(1900, 01, 01), format: formatDate), maxLines: 1, style: XStyles.xStyTextForDescr(Colors.white), overflow: TextOverflow.ellipsis);
    }
    //WIDGET NEL CASO FOSSE UN DOUBLE
    else if (xCol.dataType == double) {
      if (xCol.format == "C") {
        _xContainerOfWidgets = Text(XUtils.xFormatToCurrency(context, item[xCol.colKey] ?? 0.0), style: XStyles.xStyTextForDescr(Colors.yellow), textAlign: TextAlign.end, overflow: TextOverflow.ellipsis);
        // Se è un un semplice double
      } else {
        _xContainerOfWidgets = Text(item[xCol.colKey] != null ? item[xCol.colKey].toString() : "0.0", style: XStyles.xStyTextForDescr(Colors.yellow), overflow: TextOverflow.ellipsis);
      }
    }
    //WIDGET NEL CASO FOSSE UN INTERO
    else if (xCol.dataType == int) {
      _xContainerOfWidgets = Text(item[xCol.colKey] != null ? item[xCol.colKey].toString() : "0", style: XStyles.xStyTextForDescr(Colors.white), overflow: TextOverflow.ellipsis);

      //Se fosse una lista e voglio prendere la quantità di oggetti dentro
    } else if (xCol.dataType == bool) {
      _xContainerOfWidgets = Container(
        child: XCheckBoxWidget(
            verticalCheckBoxWidget: true,
            label: xCol.colCaption,
            label_Color: xCol.xmodelXprop.col_Color,
            activeColor: xCol.xmodelXprop.col_Color,
            checkColor: Colors.black,
            value: (item[xCol.colKey] ?? false),
            onChanged: (value) async {
              setState(() {
                editedPage.value = true;
                item[xCol.colKey] = value;
              });
            }),
      );
    } else if (xCol.dataType == String && (xCol.colKey.startsWith("li"))) {
      _xContainerOfWidgets = Container();
    } else {
      _xContainerOfWidgets = Text(xCol.headerToolTip + (item[xCol.colKey] != null ? item[xCol.colKey] : (noTextWhenCellValueIsNull ? "<No Text>" : "")), style: XStyles.xStyTextForDescr(Colors.white), overflow: TextOverflow.ellipsis);
    }
    return Container(width: xCol.width * XUtils.kforScale, child: _xContainerOfWidgets);
  }

  ///Da Overridare se vuoi aggiungere Widgets a destra dell'Item dei dettagli nell'area ROW
  Widget xDett_Item_RightWidgets(BuildContext context, T item, double height) {
    return Row(children: [Column(children: [])]);
  }

  ///Da Overridare se vuoi aggiungere Widgets a sinistra dell'Item dei dettagli nell'area ROW
  List<Widget> xDett_Item_LeftWidgets(dynamic item, void Function(void Function()) parentSetState) {
    return [];
  }

  ///Da Overridare per gestire il LongPress sul DettItem
  Future xDett_Item_xOnLongTap(dynamic item) async {
    await widget.detts_OnLongTapItem != null ? widget.detts_OnLongTapItem!(item) : null;

    rebuildAllChildren(context);
  }

  @override
  Widget build(BuildContext context) {
    var content = Column(
      mainAxisSize: MainAxisSize.min,
      children: widget.showHead ? xLayout_Render_HeadView(widget.xView) : [],
    );
    return (widget.modePage_Active.not()
        ? Container(
            margin: EdgeInsets.all(8),
            child: widget.modeDialog_Active.not()
                ////Se la scheda non si trova in un dialog
                ? xLayout_asContainer()
                : xLayout_asDialog(content))
        ////Se la scheda si trova in un dialog
        : xLayout_asPage(context));
  }

  xBoxDecorationStyleCircular_ForMenu(Color? color) {
    return BoxDecoration(color: color, borderRadius: BorderRadius.circular(4));
  }

  Widget xActionsItem_AddMedia(XFDataItem item) {
    return Container(
        child: PopupMenuButton(
      padding: EdgeInsets.all(0),
      icon: Container(padding: EdgeInsets.all(8), decoration: BoxDecoration(borderRadius: BorderRadius.circular(20), color: Colors.grey[800]), child: Icon(Icons.photo_camera_outlined, color: Colors.orange)),
      itemBuilder: (context) {
        return [
          PopupMenuItem(height: 40, child: XBtnbase(decoration: BoxDecoration(border: Border(bottom: BorderSide(color: Colors.grey[700]!))), height: 40, label: "Aggiungi Immagine", icon_WidthArea: 30, label_Style: XStyles.xStyTextForSubLabel(Colors.green), icon: Icons.visibility, icon_Size: 23, icon_Color: Colors.green, toolTip_Message: "Aggiungi un'immagine a questa riga", onPressed: () => cmd_GetMedia(setState, item))),
          PopupMenuItem(height: 40, child: XBtnbase(decoration: BoxDecoration(border: Border(bottom: BorderSide(color: Colors.grey[700]!))), height: 40, label: "Aggiungi Video", icon_WidthArea: 30, label_Style: XStyles.xStyTextForSubLabel(Colors.green), icon: Icons.visibility, icon_Size: 23, icon_Color: Colors.green, toolTip_Message: "Aggiungi un video a questa riga", onPressed: () => cmd_GetMedia(setState, item))),
          PopupMenuItem(height: 40, child: XBtnbase(decoration: BoxDecoration(border: Border(bottom: BorderSide(color: Colors.grey[700]!))), height: 40, label: "Aggiungi Audio", icon_WidthArea: 30, label_Style: XStyles.xStyTextForSubLabel(Colors.green), icon: Icons.visibility, icon_Size: 23, icon_Color: Colors.green, toolTip_Message: "Aggiungi un audio a questa riga", onPressed: () => cmd_GetAudio(setState, item))),
        ];
      },
      iconSize: 22,
    ));
  }

  Widget xActionsItem_ViewDett(XFDataItem item, bool dett_Active, void Function(void Function()) parentSetState, XView xView_Scheda, {String? title}) {
    return Container(
        child: PopupMenuButton(
      padding: EdgeInsets.all(0),
      icon: Container(padding: EdgeInsets.all(8), decoration: BoxDecoration(borderRadius: BorderRadius.circular(20), color: Colors.grey[800]), child: Icon(Icons.edit)),
      itemBuilder: (context) {
        return [
          PopupMenuItem(
              height: 40,
              child: XBtnbase(
                decoration: BoxDecoration(border: Border(bottom: BorderSide(color: Colors.grey[700]!))),
                height: 40,
                width: 180,
                label: "Vedi Dettagli",
                icon_WidthArea: 30,
                label_Style: XStyles.xStyTextForSubLabel(Colors.blue),
                icon: Icons.visibility,
                icon_Size: 23,
                icon_Color: Colors.blue,
                toolTip_Message: "Vedi i dettagli di questa riga",
                onPressed: () {
                  parentSetState(() {
                    item.isShowDetails = true;
                    item.isSel = item.isSel.not();
                  });
                },
              )),
          PopupMenuItem(
              height: 40,
              child: XBtnbase(
                decoration: BoxDecoration(border: Border(bottom: BorderSide(color: Colors.grey[700]!))),
                height: 40,
                width: 180,
                label: "Modifica",
                icon_WidthArea: 30,
                label_Style: XStyles.xStyTextForSubLabel(Colors.yellow),
                icon: Icons.edit,
                icon_Size: 23,
                icon_Color: Colors.yellow,
                toolTip_Message: "Modifica questa riga",
                onPressed: () async {
                  // Navigator.pop(context);
                  super.setState(() {
                    enteredInEditOnCell = true;
                  });
                  await showDialog(
                      context: context,
                      builder: (context) {
                        return XAlertDialog(
                            colorBackGround: XSchedaState.color_BackGround_EditDialog,
                            actionsBTNarea_Padding: EdgeInsets.symmetric(horizontal: 5),
                            title_Text: title != null ? "Scheda ${title}" : "Scheda",
                            btnNO_label: "Annulla",
                            btnYES_label: "Salva",
                            btnNO_OnPressed: () {
                              Navigator.pop(context);
                            },
                            btnYES_OnPressed: () {
                              Navigator.pop(context, item);
                            },
                            child: XScheda(
                              item,
                              xView_Scheda,
                              borderAree_Header: false,
                              modePage_Active: false,
                            ));
                      });
                  super.setState(() {
                    enteredInEditOnCell = false;
                  });
                },
              ))
        ];
      },
      iconSize: 22,
    ));
  }

  ///Widget per la costruzione di ItemComplessi utilizzati nei Dettagli della Scheda
  buildXItem<T extends XFDataItem, K>(
    T item,
    List<dynamic> liChildrens,
    Function(T) BTNadd_cmdAdd,
    void Function(void Function()) parentSetState, {
    Widget Function(dynamic)? dettItem,
    String? BTNadd_label,
    Widget? mainWidget,
    Color? backGround_Color,
    Widget Function(dynamic)? dettWidget,
    EdgeInsetsGeometry? margin,
    List<XPopUpMenuItem>? liPopUpMenu_Items,
    bool border_Visible = false,
    bool title_InMainWidget_Visible = false,
    XView? xView_Scheda,
    XView? xView_Elenco,
    XView? xViewDett,
    List<Widget>? titleLiWidgets,
    bool viewDett_Data = false,
  }) {
    return StatefulBuilder(
      builder: (context, setState) {
        return XElencoItem(item, xView_Scheda!, xViewDetts: xViewDett, margin: margin ?? EdgeInsets.only(left: 10, right: 10, bottom: 10), changeStatoWithTap: true, onTapItem: () {
          parentSetState(
            () {
              item.isShowDetails = item.isShowDetails.not();
            },
          );
        },
            showTrailingArrow: false,
            decorationBackGroundContainer: border_Visible
                ? BoxDecoration(
                    color: backGround_Color ?? Colors.grey[900],
                    border: Border(
                      left: BorderSide(),
                      right: BorderSide(),
                      top: BorderSide(),
                      bottom: BorderSide(),
                    ))
                : BoxDecoration(color: backGround_Color ?? Colors.grey[900]),
            showingDetails: item.isShowDetails,
            showMainWithDetails: true,
            childMain: Column(
              mainAxisSize: MainAxisSize.min,
              children: [
                Row(mainAxisAlignment: MainAxisAlignment.end, children: [
                  mainWidget != null ? Container() : Icon((item.isShowDetails) ? Icons.keyboard_arrow_up_outlined : Icons.keyboard_arrow_down_outlined, color: XColors.foregroundLight),
                  mainWidget != null
                      ? Container()
                      : xView_Elenco != null && widget.showHead
                          ? Expanded(
                              child: Row(children: [
                                Expanded(
                                    child: Wrap(
                                  children: xLayout_Render_HeadView(xView_Elenco, border_Visible: false),
                                ))
                              ]),
                            )
                          : Container(),
                  mainWidget != null ? Expanded(flex: 2, child: mainWidget) : Container(),
                  Container(margin: EdgeInsets.only(top: 5, right: 5, bottom: 5), child: xActionsItem_ViewDett(item, viewDett_Data, setState, xView_Scheda)),
                  media_isActive ? Container(margin: EdgeInsets.only(top: 5, right: 5, bottom: 5), child: xActionsItem_AddMedia(item)) : Container(),
                  Container(
                      margin: EdgeInsets.only(top: 5, right: 5, bottom: 5),
                      child: XBtnbase(
                          width: 40,
                          height: 40,
                          // label: BTNadd_label,
                          icon_WidthArea: 25,
                          icon: Icons.add,
                          icon_Size: 22,
                          onPressed: () {
                            FocusScope.of(context).unfocus();
                            BTNadd_cmdAdd(item);
                            setState(() {
                              item.isShowDetails = true;
                            });
                            // parentSetState(() => editedPage = true);
                          },
                          elevation: 0,
                          decoration: BoxDecoration(color: Colors.grey[800], borderRadius: BorderRadius.all(Radius.circular(25))),
                          label_Color: XColors.foregroundLight,
                          icon_Color: XColors.done)),
                  liPopUpMenu_Items != null
                      ? Container(
                          height: 30,
                          child: PopupMenuButton(
                            padding: EdgeInsets.all(1),
                            icon: Icon(Icons.more_vert_outlined),
                            itemBuilder: (context) {
                              return liPopUpMenu_Items
                                  .map((e) => PopupMenuItem(
                                      height: 40,
                                      child: XBtnbase(
                                        decoration: BoxDecoration(border: Border(bottom: BorderSide(color: Colors.grey[700]!))),
                                        height: 40,
                                        width: (e.iconImage != null || e.icon != null) ? 250 : 150,
                                        label: e.title,
                                        icon_WidthArea: 50,
                                        label_Style: XStyles.xStyTextForSubLabel(e.color),
                                        icon_Widget: e.icon != null ? null : Container(width: 50, child: e.iconImage),
                                        icon: e.iconImage != null ? null : e.icon,
                                        icon_Size: 23,
                                        icon_Color: e.iconImage != null ? null : e.color,
                                        toolTip_Message: e.toolTip_Message,
                                        onPressed: () => e.onPressed!(context, item),
                                      )))
                                  .toList();
                            },
                            iconSize: 22,
                          ))
                      : Container(),
                ])
              ],
            ),
            childDetails: Column(
              children: [
                item.isSel ? xDett_Item_HeadWidget(item, parentSetState, xclViewUI: xView_Scheda) : Container(),
                dettWidget != null
                    ? dettWidget(item)
                    : Column(
                        children: liChildrens.map((xclVoce) {
                        return dettItem!(xclVoce);
                      }).toList()),
                Container(
                    // decoration: BoxDecoration(color: colorItem_Lavoro),
                    child: Column(crossAxisAlignment: CrossAxisAlignment.start, children: [
                  //// AREA DETTAGLI  //// AREA DETTAGLI  //// AREA DETTAGLI  //// AREA DETTAGLI  //// AREA DETTAGLI  //// AREA DETTAGLI  //// AREA DETTAGLI  //// AREA DETTAGLI
                  media_isActive
                      ? (_liMediaRAW.isNotEmpty && _liMediaRAW.any((element) => element.xDocID == item.id))
                          ? Container(
                              margin: EdgeInsets.all(8),
                              decoration: BoxDecoration(border: Border.all(color: Colors.grey[700]!)),
                              child: Column(children: [
                                Row(children: [Expanded(child: Container(decoration: BoxDecoration(border: Border(bottom: BorderSide(color: Colors.grey[700]!))), child: Text("Media", textAlign: TextAlign.center, style: XStyles.xStyTextForSubLabel(XColors.foregroundLight))))]),
                                Column(
                                  children: _liMediaRAW.groupListsBy((element) => element.mediaType).entries.map((e) {
                                    if (e.key == XEnums.mediaType.audio.value) {
                                      return builder_AudioArea(_liMediaRAW.where((element) => element.mediaType == XEnums.mediaType.audio.value).toList(), item);
                                    } else if (e.key == XEnums.mediaType.image.value) {
                                      return builder_ImmaginiArea(_liMediaRAW.where((element) => element.mediaType == XEnums.mediaType.image.value).toList(), parentID: item.id);
                                    } else {
                                      return builder_VideoArea(_liMediaRAW.where((element) => element.mediaType == XEnums.mediaType.video.value).toList(), item);
                                    }
                                  }).toList(),
                                )
                              ]),
                            )
                          : Container()
                      : Container(),
                  //// AREA DETTAGLI  //// AREA DETTAGLI  //// AREA DETTAGLI  //// AREA DETTAGLI  //// AREA DETTAGLI  //// AREA DETTAGLI  //// AREA DETTAGLI  //// AREA DETTAGLI
                ]))
              ],
            ));
      },
    );
  }

  ///Widget per la costruzione dell'Head all'interno dei Dettagli
  Widget xDett_Item_HeadWidget(dynamic itemDett, void Function(void Function()) parentSetState, {XView? xclViewUI}) {
    ScrollController? _scrollController = ScrollController();
    return Scrollbar(
        thumbVisibility: true,
        controller: _scrollController,
        child: SingleChildScrollView(
            controller: _scrollController,
            child: Column(
              crossAxisAlignment: CrossAxisAlignment.start,
              mainAxisSize: MainAxisSize.min,
              children: widget.showHead ? xLayout_Render_HeadView(xclViewUI!) : [],
            )));
  }

  ///Da Overridare se si vuole intervenire prima dell'init della Scheda
  Future<bool?> xWidget_OnBeforeInit_SchLayout(T item) async {
    return null;
  }

  ///Dialog Generico da Utilizzare
  Future<bool?> xLayout_Dialog(T item, {Widget? contentWidget, String? title, String? BTN_Label_YES, String? BTN_Label_NO, bool BTNno_Visible = true, String? BTN_Label, Function()? onPressed}) async {
    return await showDialog<bool>(
        barrierDismissible: false,
        context: context,
        builder: (context) {
          return XAlertDialog(
              title_Text: title ?? "Modifica il campo qui sotto:",
              title_Style: XStyles.xStyTextForTextBase(XColors.foregroundLight),
              child: contentWidget ?? Container(),
              actionsBTNarea_Child: Row(mainAxisAlignment: MainAxisAlignment.center, children: [
                Expanded(
                    child: BTNno_Visible
                        ? XBtnbase(
                            label: BTN_Label_NO ?? "Annulla",
                            label_Style: XStyles.xStyTextForSubLabel(XColors.undo),
                            onPressed: () {
                              return Navigator.pop(context, false);
                            })
                        : Container()),
                SizedBox(width: 10),
                Expanded(
                  child: XBtnbase(
                    label: BTN_Label_YES ?? "OK, avanti..",
                    label_Style: XStyles.xStyTextForSubLabel(XColors.done),
                    onPressed: onPressed,
                  ),
                )
              ]));
        });

    // return x;
  }

  /// B L /// /// B L /// /// B L /// /// B L /// /// B L /// /// B L /// /// B L /// /// B L /// /// B L /// /// B L ///

  //Per rendere la Pagina Edited
  editPage() {
    setState(() {
      editedPage.value = true;
    });
  }

  //Per ricaricare la UI
  void rebuildAllChildren(BuildContext context) {
    void rebuild(Element el) {
      el.markNeedsBuild();
      el.visitChildren(rebuild);
    }

    (context as Element).visitChildren(rebuild);
  }

  xfillxTabs({String? xCol_Key, bool forceAdd = false}) {} //TODO da capire come fare

  _xfillxTabs({String? xCol_Key, bool forceAdd = false}) {
    xTabs.value.clear();
    return xfillxTabs(xCol_Key: xCol_Key, forceAdd: forceAdd);

    //TODO da capire come fare
    // var t = 0;
    // for (var i in widget.xView.cols) {
    //   var ifMore = widget.xView.cols.where((element) => element.colKey.startsWith("li"));
    //   if (i.colKey.startsWith("li") && itemInEdit_Clone.getProp(i.colKey).isNotEmpty) {
    //     print(itemInEdit_Clone.getProp(i.colKey).runtimeType);
    //     xTabs.value.add(XTabItem(
    //       t,
    //       i.colCaption,
    //       i.colCaption,
    //       itemClass: itemInEdit_Clone.getProp(i.colKey).runtimeType,
    //       content: xTabView_Widget(widget.xView.cols.firstWhere((element) => element.colKey == i.colKey)),
    //       labelColor_Active: widget.title_BackColor,
    //       labelColor_Disabled: ifMore.length > 1 ? null : widget.title_BackColor,
    //       iconColor_Active: widget.title_BackColor,
    //       iconColor_Disabled: ifMore.length > 1 ? null : widget.title_BackColor,
    //     ));
    //   }
    //   t++;
    // }
  }

  xfillxTabsDetts(XCol xCol, void Function(void Function()) parentSetState) async {
    var t = 0;
    liDettTabs.clear();
    for (var i in itemInEdit_Clone.getProp(xCol.colKey)) {
      liDettTabs.add(XTabItem(
          t,
          xCol.colCaption + " " + t.toString(), //
          xCol.colCaption + " " + t.toString(),
          itemClass: i,
          content: xTabViewDett_Widget(i, t, parentSetState), //tabViewPages(widget.xView.cols.firstWhere((element) => element.colKey == xCol.colKey))
          labelColor_Active: Colors.white,
          labelColor_Disabled: Colors.white,
          iconColor_Active: Colors.white,
          iconColor_Disabled: Colors.white,
          color_backGroundTab: Colors.green,
          color_backGroundTab_Activate: Colors.grey));
      t++;
    }

    detts_tabController = TabController(length: liDettTabs.length, vsync: this);
  }

  Future<List<XMediaItem>?> cmd_GetMedia(void Function(void Function()) setState, XFDataItem item) async {
    item.isShowDetails = true;
    FocusScope.of(context).unfocus();
    List<XMediaItem> liXMedias_MediaRecorder = List<XMediaItem>.empty(growable: true);
    var res = await showDialog(
        context: context,
        barrierDismissible: false,
        builder: (builder) {
          return StatefulBuilder(builder: (context, setStte) {
            return XAlertDialog(
                colorBackGround: Colors.transparent,
                actionsBTNarea_Padding: EdgeInsets.all(1),
                child: XMediaRecorder<XFDataItem>(
                  widget.key,
                  parentSetState: setState,
                  // onTake_Media: (a) {},
                  itemOriginal: item,
                  lXMedias: liXMedias_MediaRecorder,
                  xApp: widget.xApp!,
                  // onTake_Audio: (xMedia, xcl, isBusy, state) => cmd_GetAudio(setState, xcl),
                  // onTake_Picture: (image, xcl, isBusy, state) => onTakePicture(image, isBusy, setState, xcl),
                  // onTake_Video: (video, xcl, isBusy, state) => onTakeVideo(video, isBusy, setState, xcl),
                ),
                title_Text: "Fotocamera del Lavoro",
                title_Style: XStyles.xStyTextForLabel(Colors.yellow),
                content_insetPadding: EdgeInsets.all(0),
                actionsBTNarea_Child: Row(children: [
                  Expanded(
                      child: XBtnbase(
                    height: 35,
                    backGroundColor: Colors.transparent,
                    onPressed: () => Navigator.pop(context),
                    elevation: 0,
                    label: "CHIUDI",
                    label_Style: XStyles.xStyleText(colorText: Colors.red, fontSize: 24, activeBold: false),
                  ))
                ]));
          });
        });

    return _liMediaRAW.isNotEmpty ? _liMediaRAW : null;
  }

  Future<File?> cmd_GetAudio(void Function(void Function()) setState, XFDataItem xfDataItem) async {
    xfDataItem.isShowDetails = true;
    var idString = xfDataItem.id;
    if ((createAudio ?? false) || _audioRecorder!.isRecording.not()) {
      xFileUI = File.fromUri(Uri.parse("${XLibStorage.filePath}/AUDIO/${itemInEdit_Clone.id},${idString},${Uuid().v4()}_.aac"));
      await xFileUI!.create(recursive: true);
      await _audioRecorder!.openRecorder();
      await _audioRecorder!.startRecorder(toFile: xFileUI!.path);
    } else {
      await _audioRecorder!.stopRecorder();
      _audioRecorder!.closeRecorder();

      var t = await xFileUI!.readAsBytes();
      await xFileUI!.writeAsBytes(t);
      var res = xFileUI!.readAsBytesSync();
      var xclMedia = XMediaItem(Uuid().v4(), xDocID: idString, blobURL: xFileUI!.path, payload: res, mediaType: XEnums.mediaType.audio.value);
      setState(() => _liMediaRAW.add(xclMedia));
      // dataSendBackEnqueue(MapEntry(DataSendBackService.MsgEnqueueLavoriAudio, xclAudio));
    }

    return xFileUI;
  }

  onTakePicture(XFile file, bool isBusy, void Function(void Function()) setState, XFDataItem xfDataItem) async {
    var xFile;
    var idString = xfDataItem.id;
    setState(() {
      isBusy = true;
    });
    xFile = File("${XLibStorage.filePath}/IMMAGINI/${itemInEdit_Clone.id},${idString},${Uuid().v4()}_.jpg");
    await xFile.create(recursive: true);
    await xFile.writeAsBytes(await file.readAsBytes());
    var xclImage = XMediaItem(Uuid().v4(), xDocID: idString, blobURL: xFile.path, payload: await xFile.readAsBytes(), mediaType: XEnums.mediaType.image.value);
    setState(() => _liMediaRAW.add(xclImage));
    // dataSendBackEnqueue(MapEntry(DataSendBackService.MsgEnqueueLavoriImages, xclImage));
    rebuildAllChildren(context);
  }

  onTakeVideo(XFile file, bool isBusy, void Function(void Function()) setState, XFDataItem xfDataItem) async {
    File xFile;
    var idString = xfDataItem.id;
    setState(() {
      isBusy = true;
    });
    xFile = File("${XLibStorage.filePath}/VIDEO/${itemInEdit_Clone.id},${idString},${Uuid().v4()}_.mp4");
    var byteOfVideoFile = await file.readAsBytes();
    xFile.writeAsBytes(byteOfVideoFile);
    await xFile.create(recursive: true);
    var xclVideo = await XMediaItem(Uuid().v4(), xDocID: idString, blobURL: file.path, payload: byteOfVideoFile, mediaType: XEnums.mediaType.video.value);
    xclVideo.miniatura = await generateVideoThumbnail(xclVideo.blobURL!);
    setState(() => _liMediaRAW.add(xclVideo));
    // dataSendBackEnqueue(MapEntry(DataSendBackService.MsgEnqueueLavoriVideo, xclVideo));
    setState(() {
      isBusy = false;
    });
    rebuildAllChildren(context);
  }

  //Metodo che ciamo ogni volta che voglio cambiare o aggiungere una TAB
  tabsChangeActive(String tabKey, {bool forceAdd = false}) {
    //String li_ColKey,
    //TODO da capire come fare
    setState(() {
      if (forceAdd) {
        _xfillxTabs(xCol_Key: tabKey, forceAdd: forceAdd);
      } else {
        // int idx;
        var tabForKey = xTabs.value.firstWhereOrNull((element) => element.key == tabKey);
        if (tabForKey == null) {
          _xfillxTabs(xCol_Key: tabKey);
        } else {
          currentTabIndex = tabForKey.idx;
        }
      }
      xTab_Active = xTabs.value.firstWhere((element) => element.key == tabKey);
      rebuildAllChildren(context);
      enteredInEditOnCell = false;
      // currentTabIndex = xTab_Active!.idx;
    });
  }

  ///Da chiamare ogni volta che si vuole salvare il dato Clonato in quello Originale
  xcmd_Save() async {
    //se è new gli do ID, prima di save che sovrascrive
    if (itemInEdit_Clone.id == "") {
      itemInEdit_Clone.id = Uuid().v4();
    }
    editedPage.value = false;
    itemInEdit_Clone.copyProps(itemInEdit_Clone, widget.itemInEdit);
    if (media_isActive) {
      Directory direct_AUDIO = Directory("${XLibStorage.filePath}/AUDIO/");
      direct_AUDIO.listSync().clear();
      Directory direct_IMMAGINI = Directory("${XLibStorage.filePath}/IMMAGINI/");
      direct_IMMAGINI.listSync().clear();
      Directory direct_VIDEO = Directory("${XLibStorage.filePath}/VIDEO/");
      direct_VIDEO.listSync().clear();
    }
    xFillBottomBarActions();
    //_xFillBottomBarActions(editedPage.value);
    await xOnSaveAfter();
  }

  Future<bool> setImage(Uint8List payload, String blobFullName) async {
    await azureStorage.putBlob(blobFullName, bodyBytes: payload, contentType: 'image/png').whenComplete(() {});
    return true;
  }

  Future<bool> setAudio(Uint8List payload, String blobFullName) async {
    await azureStorage.putBlob(blobFullName, bodyBytes: payload, contentType: 'audio/aac');
    return true;
  }

  Future<bool> setVideo(Uint8List payload, String blobFullName) async {
    await azureStorage.putBlob(blobFullName, bodyBytes: payload, contentType: 'video/mp4');
    return true;
  }

  //quando salvo ciclo per tutte le prop dell'attore e salvo le informazioni
  ///chiamato quando il valore cambia all'interno dell EDITOR della CELLA
  xOnXCell_Edit_OnChanged(XFDataItem itemInEdit, XCol xCol, dynamic newValue) async {}

  ///called in a setState
  xOnXCell_Edit_AfterSubmit(XFDataItem itemInEdit, XCol xCol, dynamic newValue, bool valueIsChanged, {dynamic valueForResolved = null, dynamic valueForRealCol = null}) {}
  xOnXCell_Edit_BeforeSubmit(XFDataItem itemInEdit, XCol xCol, dynamic newValue, bool valueIsChanged, {dynamic valueForResolved = null, dynamic valueForRealCol = null}) async {}

  //Da chiamare per Confermare l'edit di un dato
  /// valueForRealCol = value da mettere nella col reale: es artID noi abbiamo sempre colKey = artiID_resolved, la RealCol
  xOnXCell_Edit_SubmitValue_INTERNAL(XFDataItem itemInEdit, XCol xCol, dynamic newValue, {dynamic valueForResolved = null, dynamic valueForRealCol = null}) {
    var valueIsChanged;
    if (newValue != null && newValue is XEnumDef)
      valueIsChanged = itemInEdit[xCol.colKey] != (valueForRealCol ?? newValue.value!);
    else
      valueIsChanged = itemInEdit[xCol.colKey] != (valueForRealCol ?? newValue);

    xOnXCell_Edit_BeforeSubmit(itemInEdit, xCol, newValue, valueIsChanged, valueForResolved: valueForResolved, valueForRealCol: valueForRealCol);
    xOnXCell_Edit_SubmitValue_ToItem(itemInEdit, xCol, newValue, valueIsChanged, valueForResolved: valueForResolved, valueForRealCol: valueForRealCol);
    xOnXCell_Edit_AfterSubmit(itemInEdit, xCol, newValue, valueIsChanged, valueForResolved: valueForResolved, valueForRealCol: valueForRealCol);
    calcDoc(xCol, newValue);
    updateCaption();
    setState(() {
      editedPage.value = editedPage.value | valueIsChanged;
      btnUpdateChangesShow = true;
    });
    xFillBottomBarActions();
  }

  /// only itemInEdit[xCol.colKey] = value!;
  xOnXCell_Edit_SubmitValue_ToItem(XFDataItem itemInEdit, XCol xCol, dynamic newValue, bool valueIsChanged, {dynamic valueForResolved = null, dynamic valueForRealCol = null}) {
    if (newValue is XEnumDef) {
      itemInEdit[xCol.colKey] = newValue.value;
    } else {
      // ID & _resolved
      if (xCol.colKey.endsWith("_resolved")) {
        if (valueForResolved != null) {
          itemInEdit[xCol.colKey] = valueForResolved!;
        }
        if (valueForRealCol != null) // parte del campo vero, senza _resolved
        {
          itemInEdit[xCol.colKey.replaceAll("_resolved", "")] = valueForRealCol!;
        } else {
          itemInEdit[xCol.colKey] = newValue;
        }
      } else {
        itemInEdit[xCol.colKey] = valueForRealCol ?? newValue;
      }
    }
  }

  xOnXCell_Before_Edit(XCol xCol, dynamic value, {dynamic itemToSet}) async {
    if (xEditDialog_liProps.isEmpty) {
      xEditDialog_EditCell = xCol.colCaption;
    } else {
      for (var i in xEditDialog_liProps) {
        xEditDialog_EditCell = " " + i.col_Label;
      }
    }

    if ((isAndroid() || isIOS()) && widget.modePage_Active) {
      var x = await xEditDialog(itemToSet, xEditDialog_EditCell, value, xCol);
      if (x != null) {
        itemInEdit_Clone[xCol.colKey] = x;
      }
    }
    setState(() {
      enteredInEditOnCell = false;
      btnUpdateChangesShow = false;
    });
    return () {};
  }

  void xOnChangeData(XCol xCol, dynamic newValue, void Function(void Function()) parentSetState) {}

  Future<bool> xCMD_DeleteFromList(XFDataItem itemToRemove, String title, {required List<dynamic> listFromClone_RemoveItem, required List<dynamic> listFromOriginal_RemoveItem, required Function(String) cmd_Delete}) async {
    setState(() {
      enteredInEditOnCell = true;
    });
    bool? x = await showDialog(
        barrierDismissible: false,
        context: context,
        builder: (builder) {
          return XAlertDialog(
            btnNO_label: "NO",
            btnYES_label: "SI",
            btnYES_OnPressed: () => Navigator.pop(context, true),
            btnNO_OnPressed: () => Navigator.pop(context, false),
            title_Text: title,
            title_Style: XStyles.xStyTextForSubLabel(Colors.yellow),
          );
        });

    if (x != null && x) {
      editedPage.value = true;

      if (listFromClone_RemoveItem.isEmpty) {
        xBottomBarActions_Fill(editedPage.value);
      }
      var res = listFromOriginal_RemoveItem.firstWhereOrNull((element) => element.id == itemToRemove.id);

      if (res != null) {
        if (itemToRemove.id == "") {
          return false;
        } else {
          listFromClone_RemoveItem.remove(itemToRemove);
          setState(() {
            enteredInEditOnCell = false;
          });
          await cmd_Delete(itemToRemove.id);
          return true;
        }
      } else {
        setState(() {
          enteredInEditOnCell = false;
        });
        return false;
      }
    } else {
      setState(() {
        enteredInEditOnCell = false;
      });
      return false;
    }
  }

  Future<bool> cmd_Back() async {
    if (editedPage.value) {
      var res = await showDialog(
          context: context,
          builder: (context) {
            return XAlertDialog(
              title_Text: "Vuoi salvare le tue modifiche?",
              title_Style: XStyles.xStyTextForSubLabel(Colors.yellow),
              actionsBTNarea_Child: Row(children: [
                Expanded(child: XBtnbase(label: "Annulla", label_Style: XStyles.xStyTextForDescr(Colors.yellow), onPressed: () => Navigator.pop(context, null))),
                Expanded(child: XBtnbase(label: "No", label_Style: XStyles.xStyTextForDescr(Colors.red), onPressed: () => Navigator.pop(context, false))),
                Expanded(child: XBtnbase(label: "Si", label_Style: XStyles.xStyTextForDescr(Colors.green), onPressed: () => Navigator.pop(context, true))),
              ]),
            );
          });
      if (res == null) {
        return false;
      } else if (res) {
        xcmd_Save();
        Navigator.pop(context, widget.itemInEdit);
        return true;
      } else {
        Navigator.pop(context);
        return false;
      }
    } else {
      editedPage.value = false;
      Navigator.pop(context);
      return true;
    }
  }

  xFillBottomBarActions() {
    liBottomActions.clear();
    //XFX
    if ((editedPage.value)) {
      liBottomActions.add(XBottomNavigationBarItem("save", label: "Salva", icon: Container(width: 30, child: XIcons.save_ALL_white), tooltip: "Salva le modifiche e rimane quì"));
      liBottomActions.add(XBottomNavigationBarItem("saveExit", label: "Salva e\nChiudi", icon: Container(width: 40, child: Icon(Icons.undo, color: Colors.green, size: 30)), tooltip: "Salva le modifiche e chiude la scheda"));
    }
    //XFX xché è l'ADD egenrico della XSCH 1a a DX
    if (xInitList_AddDetts().isNotEmpty && widget.xDett_AddBTN_Active) {
      liBottomActions.add(XBottomNavigationBarItem("addDett", label: "Aggiungi\nDettaglio", icon: Container(width: 40, child: Icon(Icons.note_add_sharp, color: widget.title_Color, size: 30)), tooltip: "Aggiungi un dettaglio..."));
    }
    xBottomBarActions_Fill(editedPage.value);
  }

  ///toBE OVERRIDE chiamata 2 volte, in init e in LAYOUT. la prima serve per far sapere al LAY che deve avere la BottomNavBar senza dover mettere un bool apposta
  xBottomBarActions_Fill(bool dataChanged) {}

  _xBottomBarAction_OnTap(int currentIdx, void Function(void Function()) parentSetState) async {
    var act = liBottomActions[currentIdx];
    xBottomBarAction_OnTap(currentIdx, act, parentSetState);
  }

  xBottomBarAction_OnTap(int currentIdx, XBottomNavigationBarItem act, void Function(void Function()) parentSetState) async {
    var act = liBottomActions[currentIdx];
    if (act.wKey == "saveExit") {
      setState(() {
        waiterMessage = "Sto salvando i tuoi dati..";
        isBusy = true;
      });
      await xcmd_Save();
      setState(() {
        waiterMessage = "";
        isBusy = false;
      });
      Navigator.pop(context, widget.itemInEdit);
    } else if (act.wKey == "save") {
      setState(() {
        waiterMessage = "Sto salvando i tuoi dati..";
        isBusy = true;
      });
      await xcmd_Save();
      setState(() {
        waiterMessage = "";
        isBusy = false;
      });
    }
    if (act.wKey == "addDett") {
      _OnAddNewDett();
    }
  }

  XFDataItem xOnAddNewDett_INTERNAL(XFDataItem item) {
    if (item.id == "") item.id = Uuid().v4();
    return xOnAddNewDett(item);
  }

  XFDataItem xOnAddNewDett(XFDataItem item) {
    return item;
  }

  List<XItem_BTNadd> xInitList_AddDetts() {
    return [];
  }

  _OnAddNewDett() async {
    var x = await xInitList_AddDetts();
    // for (var wi in ws) {}
    var t;
    if (x.length == 1) {
      var p = xTabs.value.firstWhereOrNull((element) => element.key == x.first.key);
      if (p == null) {
        tabsChangeActive(x.first.key, forceAdd: true);
      } else {
        tabsChangeActive(x.first.key);
      }
      t = x.first.key;
    } else {
      t = await showDialog(
          context: context,
          builder: (context) {
            return XAlertDialog(
                height: null,
                title_Text: "Scegli quale dettaglio aggiungere:",
                btnNO_label: "",
                btnYES_Labelcolor: XColors.undo,
                btnYES_OnPressed: () {
                  Navigator.pop(context, null);
                },
                btnYES_label: "Chiudi",
                title_Style: XStyles.xStyTextForTextBase(),
                child: Column(
                    mainAxisSize: MainAxisSize.min,
                    children: x
                        .map(
                          (e) => Row(children: [
                            Expanded(
                                child: XBtnbase(
                              margin: EdgeInsets.symmetric(vertical: 5),
                              label: e.label,
                              backGroundColor: Colors.grey[800],
                              height: 35,
                              onPressed: () {
                                var x = xTabs.value.firstWhereOrNull((element) => element.key == e.key);
                                if (x == null) {
                                  tabsChangeActive(e.key, forceAdd: true);
                                } else {
                                  tabsChangeActive(e.key);
                                }

                                Navigator.pop(context, e.key);
                              },
                              label_Style: XStyles.xStyTextForSubLabel(e.backgroundColor),
                            ))
                          ]),
                        )
                        .toList()));
          });
    }

    if (t != null && t != "" && t == xTab_Active!.key) {
      var y = xTab_Active!.itemClass!.getCloneFull();
      var xclObject = xOnAddNewDett_INTERNAL(y);
      var res = await xLayout_DialogAddItem(xTab_Active!.xElencoToView!.view!, xclObject, setState);
      var resBeforeAddItemInList;
      if (res != null) {
        resBeforeAddItemInList = await xOnBeforeAddDett(res);
        editedPage.value = true; //x ADD
      }

      var liToAddItem = itemInEdit_Clone.getProp(t);
      var x = xTabs.value.firstWhereOrNull((element) => element.key == xTab_Active!.key);
      if (res != null) {
        liToAddItem.add(resBeforeAddItemInList);
        xOnAfterActionOnDett_INTERNAL(resBeforeAddItemInList!);

        if (x != null) {
          currentTabIndex = x.idx;
        } else {
          currentTabIndex = xTab_Active!.idx;
        }
      } else {
        if (liToAddItem.isEmpty) {
          xTabs.value.remove(x);
        } else {}
      }
      calcDoc(null, liToAddItem);
    }
  }

  XFDataItem? xOnBeforeAddDett(XFDataItem xclObject) {
    return xclObject;
  }

  /// DO NOTHING =>     widget.title = itemInEdit_Clone .isNew ? "Nuovo Cliente" : itemInEdit_Clone.nickName;;
  updateCaption() {
    if (widget.title == null || widget.title == "") widget.title = (itemInEdit_Clone.isNew ? "Nuovo " : "") + itemInEdit_Clone.X_docCaption!;
  }

  /// NOT TO OVERRIDE !
  XFDataItem? xOnAfterActionOnDett_INTERNAL(XFDataItem xclObject) {
    superSetState(() {
      editedPage.value = true;
    });
    calcDoc(null, xclObject);
    xFillBottomBarActions();
    return xOnAfterActionOnDett(xclObject);
  }

  XFDataItem? xOnAfterActionOnDett(XFDataItem xclObject) {
    return xclObject;
  }

  Future<XFDataItem?> xOnActionOnDett(XFDataItem xclObject) async {
    return xclObject;
  }
}

class ScontiBTN {
  String scontoValue;
  int positionY;
  int? positionX;
  ScontiBTN({required this.scontoValue, required this.positionY, this.positionX});
}

class XItem_BTNadd {
  String key;
  String label;
  Color backgroundColor;
  XItem_BTNadd({required this.key, required this.label, required this.backgroundColor});
}
