library xfxwidgets;

import 'dart:io';
import 'dart:math';
import 'package:android_intent_plus/android_intent.dart';
import 'package:android_intent_plus/flag.dart';
import 'package:collection/collection.dart';
import 'package:flutter/material.dart';
import 'package:path_provider/path_provider.dart';
import 'package:xcommonwidgets/xcommonwidgets.dart';
import 'package:xfxbase/XBL/XAzureRest.dart';
import 'package:xfxbase/XFDataItem.dart';
import 'package:xfxbase/_XFX/XF_Col.dart';
import 'package:xfxbase/_XFX/XF_View.dart';
import 'package:xtoolspackage/XLibStorage.dart';
import 'package:xtoolspackage/xtoolspackage.dart';

import 'XF_ELENCO/XElenco.dart';
import 'XF_MAIN/XApp.dart';
import 'XTabItem.dart';

part 'XF_ELENCO/XElencoItem.dart';
part 'XF_SCHEDA/XfxSchedaTapped.dart';
part 'XF_SCHEDA/XfxScheda.dart';
part 'XfxUpdater.dart';

abstract class XEnums {
  static XEnumMediaType mediaType = XEnumMediaType();
}

class XEnumMediaType<int> extends XEnum {
  XEnumDef image = XEnumDef(value: 0, label: 'Image', backColor: Color.fromARGB(255, 0, 0, 0), textColor: Color.fromARGB(255, 0, 0, 0));
  XEnumDef audio = XEnumDef(value: 1, label: 'Audio', backColor: Color.fromARGB(255, 0, 0, 0), textColor: Color.fromARGB(255, 0, 0, 0));
  XEnumDef video = XEnumDef(value: 2, label: 'Video', backColor: Color.fromARGB(255, 0, 0, 0), textColor: Color.fromARGB(255, 0, 0, 0));
  XEnumDef panoramica = XEnumDef(value: 10, label: 'Panoramica', backColor: Color.fromARGB(255, 0, 0, 0), textColor: Color.fromARGB(255, 0, 0, 0));
  XEnumDef multiImage = XEnumDef(value: 20, label: 'MultiImage', backColor: Color.fromARGB(255, 0, 0, 0), textColor: Color.fromARGB(255, 0, 0, 0));
  @override
  void initDefinitions() {
    definitions[0] = image;
    definitions[1] = audio;
    definitions[2] = video;
    definitions[10] = panoramica;
    definitions[20] = multiImage;
  }
}

abstract class XfxUtils {
  static String GetStringFromValue(dynamic value, {XProp? colForXDataItem = null}) {
    if (value is XFDataItem) {
      var str = value[colForXDataItem!.col_Name].toString();
      return str;
    } else if (value is XEnumDef) {
      return value.label;
    } else
      return value.toString();
  }

  static String xddValueToString(Object? value, Iterable<XProp> colsOfXFdataItemToShow) {
    if (value is XFDataItem) {
      return xddValueToString_XFD(value, colsOfXFdataItemToShow);
    } else if (value is XEnumDef) {
      return value.label;
    } else
      return value.toString();
  }

  static String xddValueToString_XFD(XFDataItem value, Iterable<XProp> colsOfXFdataItemToShow) {
    var str = "";
    colsOfXFdataItemToShow.forEach((element) {
      str += (str.isEmpty ? "" : " ") + value[element.col_Name].toString();
    });
    return str;
  }
}
